import { select , geoMercator, json, geoPath, event,zoom } from 'd3';
const width = document.body.clientWidth;
const height = document.body.clientHeight;
const svg = select('svg').attr('width', width).attr('height', height);
const g = svg.append('g');
const mercator = geoMercator().scale(30000).translate([width/2, height/2]).center([73,19.7]);
const pathGenerator = geoPath().projection(mercator);
//Zoom
svg.call(zoom().on('zoom',() =>{
	g.attr('transform',event.transform)
}))
//Reading data

const render = data => {
  
  // console.log(data);
let c1Value  = d => d.properties.c1;

const min = d3.min(data,c1Value);
const max = d3.max(data,c1Value);
const comp = (max - min)/3;
// Define the div for the tooltip
const onMouseOver = d =>{	
tooltip.transition().duration(200).style("opacity", .9);		
tooltip.html("<b>"+d.properties.Block+"</b><br><b>Stunted child:</b>"+d.properties.c1)
    .style("left", d3.event.pageX + "px")
    .style("top",  d3.event.pageY - 30 + "px");	
}
 var tooltip = d3.select("body").append("div") 
        .attr("class", "tooltip")       
        .style("opacity", 0);

var myColor = v =>{
  if(v>=min && v < min + comp)
    return 'red';
  else if(v >= min+comp && v<max-comp)
    return 'yellow';
  else if(v >= max-comp)
    return 'green';
}
  
	const paths = g.selectAll('path').data(data)
  .enter().append('path').attr('d',pathGenerator).attr('class','my-block')
  .style("fill", function(d) {
      var value = d.properties.c1;
      return myColor(value);
		}).on("mouseover", d => onMouseOver(d))          
      .on("mouseout", function(d) {   
            tooltip.transition()    
            .duration(500)    
            .style("opacity", 0); 
          });
  
  
   g.selectAll("text").data(data)
    .enter().append("text")
    .text(d => d.properties.Block)
    .attr("x", function(d){
        return pathGenerator.centroid(d)[0];
    })
    .attr("y", function(d){
        return  pathGenerator.centroid(d)[1];
    })
    .attr("text-anchor","middle")
    .attr('font-size','12pt')
    .attr("font-family", "sans-serif");
}
d3.csv("data.csv").then(data =>{
  d3.json('block.geojson').then(json =>{
    for (var i = 0; i < data.length; i++) {
    	var dataBlock = data[i].Block;
      var datac1 = data[i].c1;
      
    for (var j = 0; j < json.features.length; j++)  {
        var jsonBlock = json.features[j].properties.Block;

        if (dataBlock == jsonBlock) {

        json.features[j].properties.c1 = datac1; 

        break;
      }
    }
    }
    render(json.features);
  })
})

